在github操作中使用特定的docker版本

问题描述 投票:3回答:1

[我想使用github操作来测试sbt-native-packager Docker集成,该集成从Dockerfiles构建Docker映像。

问题是,github操作似乎使用了旧的或自定义的docker版本。 3.0.8被检测为版本。参见a failed integration test run,其中指出

[[1]检测到的Docker版本DockerVersion(3,0,8,None)与DockerPermissionStrategy.MultiStage不兼容

我想使用最新的docker版本19.x,该版本允许我们测试所有功能。理想情况下,我能够为不同的测试场景设置不同的docker版本,但这太好了。

更新

my debug docker github action的输出

docker version
Client:
 Version:           3.0.8
 API version:       1.40
 Go version:        go1.12.10
 Git commit:        2355349d
 Built:             Wed Oct 23 17:47:59 2019
 OS/Arch:           linux/amd64
 Experimental:      false

Server:
 Engine:
  Version:          3.0.8
  API version:      1.40 (minimum version 1.12)
  Go version:       go1.12.10
  Git commit:       adfac69
  Built:            Wed Oct 23 17:54:47 2019
  OS/Arch:          linux/amd64
  Experimental:     false
 containerd:
  Version:          v1.2.10
  GitCommit:        b34a5c8af56e510852c35414db4c1f4fa6172339
 runc:
  Version:          1.0.0-rc8+dev
  GitCommit:        3e425f80a8c931f88e6d94a8c831b9d5aa481657
 docker-init:
  Version:          0.18.0
  GitCommit:        fec3683

docker --version

Docker version 3.0.8, build 2355349d

预先感谢,Muki

docker sbt-native-packager github-actions
1个回答
0
投票

您可以使用Ubuntu安装方法来安装最新版本的docker!

[在您的工作流程中,设置VM以安装docker,然后检查版本。 I've verified it in this workflow并在此处发布了YAML:

name: Check Docker Version

on: [push]

jobs:
  build:
    runs-on: ubuntu-latest
    steps:
    - name: Check Docker Version
      run: docker --version
    - name: Install Latest Docker
      run: |
        curl -fsSL https://download.docker.com/linux/ubuntu/gpg | sudo apt-key add -
        sudo add-apt-repository "deb [arch=amd64] https://download.docker.com/linux/ubuntu  $(lsb_release -cs)  stable"
        sudo apt-get update
        sudo apt-get install docker-ce
    - name: Check Docker Version
      run: docker --version

每次安装每个版本都必须安装docker可能很麻烦,但是至少您可以通过这种方式来控制版本。 :D

我应该补充一点,作业中的每个步骤都可以访问您安装的版本。如果您需要在另一个job中使用docker,则必须为新的计算资源安装docker。

热门问题
推荐问题
最新问题